<?php

if ( !defined('INTRAMESSENGER') )
{
  exit;
}

function textFilter($text, $file)
{
	$text = supSpecialChar($text);
	$tab = array();
	if (file_exists($file))
	{
		$tab = file($file);
		if (count($tab) > 0 )
		{
      for ($i=0;$i < count($tab);$i++)
      {
        $motformat = supSpecialChar(trim($tab[$i]));
        if (eregi($motformat, $text))
        {
          return true;
        }
      }
    }
	}
	//
	return false;
}


function textCensure($text, $file)
{
	//$text = supSpecialChar($text);
	$tab = array();
	if (file_exists($file))
	{
		$tab = file($file);
		if (count($tab) > 0 )
		{
      for ($i=0;$i < count($tab);$i++)
      {
        $text = str_replace(trim($tab[$i]), "...", $text);  //    "..." ou "[censur]"
      }
    }
	}
  //
	return $text;
}


function supSpecialChar($string)
{
	$start = array("//","//","//","//","//","//","//","//","//","//","//",
	"//","//","//","//","//","//","//","//","//","//","//","//","//","//",
	"//","//","//","//","//","//","//","//","//","//","//","//","//","//",
	"//","//","//","//","//","//","//","//","//","//","//","//","//","//",
	"//","//","//","//","//","//","//");
	$end = array("A","A","A","A","A","A","A","a","a","a","a","a","a","a","E","E",
	"E","E","e","e","e","e","I","I","I","I","i","i","i","i","O","O","O","O","O","O",
	"o","o","o","o","o","o","U","U","U","U","u","u","u","u","B","C","c","D","d","N",
	"n","P","p","Y");
	//
	$newString = preg_replace($start, $end, $string);
	//
	return strtolower($newString);
}
?>
